package ccyg.aftersales.api;

package ..deTemp.1732171092401;

import ccyg.aftersales.dao.CostAdjustmentDao;
import ccyg.aftersales.dao.CostAdjustmentEntryDao;
import ccyg.aftersales.util.ApiUtil;
import ccyg.utils.ABillServiceHelper;
import com.alibaba.fastjson.JSONObject;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import kd.bos.bill.IBillView;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.logging.Log;
import kd.bos.logging.LogFactory;
import kd.bos.openapi.common.custom.annotation.ApiController;
import kd.bos.openapi.common.custom.annotation.ApiMapping;
import kd.bos.openapi.common.custom.annotation.ApiParam;
import kd.bos.openapi.common.custom.annotation.ApiPostMapping;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.operation.OperationServiceHelper;

@ApiMapping("/CostAdjustments")
@ApiController(value = "CostAdjustments", desc = "")
public class CostAdjustmentsApi {
  protected final Log logger = LogFactory.getLog(ccyg.aftersales.api.CostAdjustmentsApi.class);
  
  private static final String SUB_ENTITY = "cal_costadjust_subentity";
  
  private static final String RESULT_STATUS = "status";
  
  private static final String RESULT_MESSAGE = "message";
  
  private static final String RESULT_CODE = "errorCode";
  
  @ApiPostMapping("routeAdd")
  public CustomApiResult<Object> routeAdd(@ApiParam("成本调整单字段详情") CostAdjustmentDao costAdjustmentsInformation) {
    this.logger.info("成本调整单字段详情:" + costAdjustmentsInformation);
    CustomApiResult<Object> webApiResult = new CustomApiResult();
    webApiResult.setData(new JSONObject());
    if (costAdjustmentsInformation == null) {
      webApiResult.setStatus(false);
      webApiResult.setErrorCode("9999");
      webApiResult.setMessage("入参为空");
      return webApiResult;
    } 
    if (costAdjustmentsInformation.getCostAdjustmentEntryList() == null || costAdjustmentsInformation.getCostAdjustmentEntryList().size() == 0) {
      webApiResult.setStatus(false);
      webApiResult.setErrorCode("9999");
      webApiResult.setMessage("单据体分录为空");
      return webApiResult;
    } 
    Map<String, Object> stringObjectMap = setCostAdjustments(costAdjustmentsInformation);
    webApiResult.setStatus(((Boolean)stringObjectMap.get("status")).booleanValue());
    webApiResult.setErrorCode(stringObjectMap.get("errorCode").toString());
    webApiResult.setMessage(stringObjectMap.get("message").toString());
    return webApiResult;
  }
  
  protected Map<String, Object> setCostAdjustments(CostAdjustmentDao costAdjustmentsInformation) {
    DynamicObject costAdjustments = ApiUtil.getDynamicObject("cal_costadjust_subentity", (new QFilter("billno", "=", "9999999999"))
        .toArray(), true);
    IBillView formVIew = (IBillView)ABillServiceHelper.createAddView("cal_costadjust_subentity");
    IDataModel costAdjustModel = formVIew.getModel();
    this.logger.info("视图：" + formVIew);
    costAdjustModel.createNewData(costAdjustments);
    costAdjustModel.setValue("calorg", ApiUtil.getDynamicObject("bos_org", (new QFilter("number", "=", costAdjustmentsInformation
            .getCalOrg())).toArray(), false));
    costAdjustModel.setValue("costaccount", ApiUtil.getDynamicObject("cal_bd_costaccount", (new QFilter("calorg.id", "=", 
            Long.valueOf(costAdjustments.getLong("calorg.id")))).toArray(), false));
    costAdjustModel.setValue("difftype", "B");
    costAdjustModel.setValue("createtype", "A");
    costAdjustModel.setValue("custsupplier", ApiUtil.getDynamicObject("bd_supplier", (new QFilter("number", "=", costAdjustmentsInformation
            .getCusSupplier())).toArray(), false));
    costAdjustModel.setValue("biztype", costAdjustmentsInformation.getBizType());
    costAdjustModel.setValue("bip_checkboxfield", Boolean.valueOf(true));
    costAdjustModel.setValue("adminorg", ApiUtil.getDynamicObject("bos_org", (new QFilter("number", "=", costAdjustmentsInformation
            .getCalOrg())).toArray(), false));
    costAdjustModel.setValue("billstatus", "A");
    costAdjustModel.setValue("bookdate", new Date());
    List<CostAdjustmentEntryDao> costAdjustmentEntryList = costAdjustmentsInformation.getCostAdjustmentEntryList();
    for (CostAdjustmentEntryDao costAdjustmentEntry : costAdjustmentEntryList)
      setCostAdjustmentsEntry(costAdjustmentEntry, costAdjustModel); 
    DynamicObject dataEntity = costAdjustModel.getDataEntity();
    Map<String, Object> returnMap = new HashMap<>();
    OperationResult save = OperationServiceHelper.executeOperate("save", dataEntity
        .getDynamicObjectType().getName(), new DynamicObject[] { dataEntity }, OperateOption.create());
    this.logger.info("保存：" + save);
    if (save.isSuccess()) {
      OperationResult submit = OperationServiceHelper.executeOperate("submit", dataEntity
          .getDynamicObjectType().getName(), new DynamicObject[] { dataEntity }, OperateOption.create());
      this.logger.info("提交：" + submit);
      if (submit.isSuccess()) {
        OperationResult audit = OperationServiceHelper.executeOperate("audit", dataEntity
            .getDynamicObjectType().getName(), new DynamicObject[] { dataEntity }, OperateOption.create());
        this.logger.info("审核：" + audit);
        if (!audit.isSuccess()) {
          returnMap.put("errorCode", "-3");
          returnMap.put("status", Boolean.valueOf(false));
          returnMap.put("message", "审核：" + audit.getMessage() + "," + audit.getAllErrorOrValidateInfo().toString());
        } 
      } else {
        returnMap.put("errorCode", "-2");
        returnMap.put("status", Boolean.valueOf(false));
        returnMap.put("message", "提交:" + submit.getMessage() + "," + submit.getAllErrorOrValidateInfo().toString());
        return returnMap;
      } 
    } else {
      returnMap.put("errorCode", "-1");
      returnMap.put("status", Boolean.valueOf(false));
      returnMap.put("message", "保存:" + save.getMessage() + "," + save.getAllErrorOrValidateInfo().toString());
      return returnMap;
    } 
    returnMap.put("errorCode", "0000");
    returnMap.put("status", Boolean.valueOf(true));
    returnMap.put("message", "SUCCESS");
    return returnMap;
  }
  
  protected void setCostAdjustmentsEntry(CostAdjustmentEntryDao costAdjustmentsInformationLine, IDataModel costAdjustModel) {
    int newEntryRow = costAdjustModel.createNewEntryRow("entryentity");
    costAdjustModel.setValue("storageorgunit", costAdjustModel.getValue("calorg"), newEntryRow);
    costAdjustModel.setValue("material", ApiUtil.getDynamicObject("bd_material", (new QFilter("number", "=", costAdjustmentsInformationLine
            .getMaterial())).toArray(), false), newEntryRow);
    costAdjustModel.setValue("adjustamt", costAdjustmentsInformationLine.getAdjustAmt(), newEntryRow);
    DynamicObject calOrg = (DynamicObject)costAdjustModel.getValue("calorg");
    costAdjustModel.setValue("warehouse", ApiUtil.getDynamicObject("bd_warehouse", (new QFilter("createorg.number", "=", calOrg
            .getString("number"))).toArray(), false), newEntryRow);
  }
}
